import React, { useState, useEffect } from 'react';
import style from './Console.module.scss';

export const Console = ({ isOpen, close }) => {
  const [output, setOutput] = useState([]);
  const [command, setCommand] = useState('');

  useEffect(() => {
    window.console = {
      log: (...args) => setOutput((output) => [...output, args.join(' ')]),
      error: (...args) => setOutput((output) => [...output, args.join(' ')]),
      clear: () => setOutput([]),
    };
  }, []);

  const handleCommandChange = (event) => {
    setCommand(event.target.value);
  };

  const handleKeyDown = (event) => {
    if (event.key === 'Enter') {
      try {
        const result = eval(event.target.value);
        setOutput((output) => [...output, result]);
      } catch (e) {
        setOutput((output) => [...output, e.toString()]);
      }
      setCommand('');
      event.preventDefault();
    }
  };

  if (isOpen) {
    return (
      <div className={style.console}>
        <div className={style.header}>
          <h2>Console</h2>
          <button onClick={() => window.console.clear()}>Clear</button>
          <button onClick={close}>x</button>
        </div>
        <div className={style.out}>
          {output.map((item, index) => (
            <div key={index}>{item}</div>
          ))}
        </div>
        <div className={style.entryField}>
          <span>&#62;</span>
          <input
            type="text"
            value={command}
            onChange={handleCommandChange}
            onKeyDown={handleKeyDown}
          />
        </div>
      </div>
    );
  } else {
    return null;
  }
};
